-- misc outputs
library ieee;
use ieee.std_logic_1164.all;
library exemplar;
use exemplar.exemplar_1164.all;
use std.textio.all;

entity outputs is
    port (
		hen_in : out std_logic_vector(3 downto 0)
   );
end outputs;

library ieee;
use ieee.std_logic_1164.all;
library exemplar;
use exemplar.exemplar_1164.all;
use std.textio.all;

architecture operate_outputs of outputs is

type memory is array (integer range <>) of integer;


procedure f_rominit(rom : inout memory; file romdef : TEXT) is
variable l : line;
variable j : integer;
variable chr : character;
        type hex_to_v4_t is array(character) of integer;
        constant hex_to_v4 : hex_to_v4_t := (
            '0' => 0,
            '1' => 1,
            '2' => 2,
            '3' => 3,
            '4' => 4,
            '5' => 5,
            '6' => 6,
            '7' => 7,
            '8' => 8,
            '9' => 9,
            'a' | 'A' => 10,
            'b' | 'B' => 11,
            'c' | 'C' => 12,
            'd' | 'D' => 13,
            'e' | 'E' => 14,
            'f' | 'F' => 15,
            others => 0);

        -------------------------------------------
        -- convert a hex string to integer
        -------------------------------------------
        function hex_line_to_v( s : string) return integer is
            variable mult : integer :=1;
            variable result : integer :=0;
        begin
            for i in s'reverse_range loop
                result := result + (hex_to_v4(s(i))*mult);
                mult := mult*16;
            end loop;
            return result;
        end function;
begin
  for j in rom'range loop
    readline(romdef,l);
    if endfile(romdef) then exit; end if;
    rom(j) := hex_line_to_v(l.all);
  end loop;
end f_rominit;

constant HEN1STR  : string := "hen1.tab";
FILE HEN1T : TEXT open read_mode is HEN1STR;  
constant hen_time : time := 37 ns;


begin


proc_hen1 : process	
variable HEN1 : memory(1 to 16);
variable hi : integer :=1;
variable forever : integer :=16000000;
begin
  f_rominit(HEN1,HEN1T);
  for i in 0 to forever loop
    wait for hen_time;
	  hen_in <= int2evec(HEN1(hi),4);
	  hi := hi+1;
      if hi>HEN1'high then
        hi := 1;
      end if;
  end loop;
end process;
  
end operate_outputs;

